'''
Created on Mar 11, 2016

@author: mukuze
'''

'''
A duplicate of the Visualization module in order to use it in the GUI application
'''

'''imports'''

# other built in modules

import numpy as np
import os.path
from copy import deepcopy
import operator
import sys


# global variables
input_f=""
input_mat=[]


# function that accepts values from the main GUI_interactiveBMF frame and sets the global 
# variables to those values to be used by the functions here
# only the path of the input file and input matrix need to be set accordingly so the results returned by some functions are right
def get_set_values(input_file_path, full_mat):
    global input_f 
    input_f=input_file_path
    global input_mat
    input_mat=full_mat

# Exception class
class BreakOutOfALoop(Exception): pass

# function to save the names of the columns and the rows in the data
def get_col_row_names():
    rows_names = []
    cols_names = []
    
    if os.path.dirname(input_f)=="":
        file1='row_names'
        file2='column_names'
    else:
        file1=os.path.dirname(input_f)+'/row_names'
        file2=os.path.dirname(input_f)+'/column_names'
        
    if os.path.isfile(file1): 
        for word in open(file1):
            rows_names.append(word.rstrip('\n'))
    else:
        rows_names=[x for x in range(0,len(input_mat[:,0]))]
        
    if os.path.isfile(file2):    
        for word in open(file2):
            cols_names.append(word.rstrip('\n'))
    else:
        cols_names=[x for x in range(0,len(input_mat[0]))]
    
    return rows_names,cols_names
        
# function to save the final factors/patterns
def save_factors(clitems,trans_sets,factoritems,columnnames,rownames):
#     This is the output that we want the user to see:
#     
#     The final patterns (factors and their transactions) are as follows
#     This set of items    is most probable in    this set of transactions
#     e.g.
#     Contacts, Messages    is most probabale in    yahoo, facebook, twitter
        try:
            f_write=os.path.dirname(input_f)+'/patterns.txt'
            f = open(f_write, "w")
            f.write("\nThe final patterns (factors and their transactions) are as follows\n\n")
            f.write("This set of items    ---is most probable in--->    this set of transactions\n\n")
            for y in factoritems:
                selected_cols=[columnnames[x] for x in clitems[y]]
                if rownames!=[]:
                    selected_rows=[rownames[x] for x in trans_sets[y]]
                else:
                    selected_rows=trans_sets[y]
        
                f.write("{} \t---->\t {}\n".format(", ".join(selected_cols), ", ".join(selected_rows)))
            
            # return True to signal that the factors were successfully saved    
            return True
         
        except TypeError:
            # return False to signal that the factors were not successfully saved
            return False

# a function that sorts the factor_items in increasing number of 1's the cover alone 
# so the factor that covers the least ones alone comes first      
def sort_number_1s(scores):
    sorted_scores = sorted(scores.items(), key=operator.itemgetter(1))
    return sorted_scores

# function that returns the matrix multiplication of the two rank-1 matrices corresponding to the indexed factor_item 
# the first rank-1 matrix is the boolean matrix with 1 at the indexes covered by the closed itemset itself and
# the second is the boolean matrix with 1 at the indexes in the transactions containing the closed itemset
def vec_gen(clitems,trans_sets,factoritem, indx,nb_cols,nb_rows):
    mylist1=list(clitems[factoritem[indx]])
    mylist2=list(trans_sets[factoritem[indx]])
    row_vec=np.zeros((1,nb_cols))
    col_vec=np.zeros((nb_rows,1))
    for i in mylist1:
        row_vec[0][i]=1
    for j in mylist2:
        col_vec[j]=1
    return col_vec.dot(row_vec)

# permute so the rows which are covered by the itemset come top left corner
def permute_rows(mat,trans_sets,factoritem, indx):
    myrows=list(trans_sets[factoritem[indx]])
    row_order=[x for x in range(len(mat))]
    mat_copy = deepcopy(mat)
    row_order_copy = deepcopy(row_order)
    cnt=0
    for x in myrows:
        temp=mat_copy[cnt]
        temp1=row_order_copy[cnt]
        mat[cnt]=mat[x]
        row_order[cnt]=row_order[x]
        mat[x]=temp
        row_order[x]=temp1
        cnt+=1
    return mat, row_order

# selects the ones covered by a particular factor_item from the whole matrix
# need to provide the index of the particular factor_item
def select_factor(mat,clitems,trans_sets,factoritem, indx):
    mylist1=list(clitems[factoritem[indx]])
    mylist2=list(trans_sets[factoritem[indx]])
    new_arr=np.zeros_like(mat)
    for x in mylist2:
        for y in mylist1:
            new_arr[x,y]=1
    return new_arr

# sorts the matrix in descending order and returns the sorted indices 
def sort_indx(factor):
    # sorting and getting sorted indices as well
    indices_=(-factor).argsort(axis=1)
    
    factor.sort(axis=1)
    factor=factor[:,::-1]  
    return indices_

# generates the full data by adding each factor_item till all are added 
def gen_matrix(clitems,trans_sets,factoritem,nb_cols,nb_rows):
    mat=vec_gen(clitems,trans_sets,factoritem,0,nb_cols,nb_rows)
    full_mat=np.zeros_like(mat)
    for x in range(len(factoritem)):
        full_mat+= vec_gen(clitems,trans_sets,factoritem,x,nb_cols,nb_rows)
    return full_mat
